﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Activity
Version=9.801
@EndOfDesignText@
#Region  Activity Attributes 
	#Region  Activity Attributes 
	#FullScreen: False
	#IncludeTitle: True
#End Region

Sub Process_Globals
	Private xui As XUI
	' FICHA DO PRODUTO
End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.

	Private dialog As B4XDialog
	Private bStopPulsar As Boolean

	Private Drawer As B4XDrawer

	Private CLV1 As CustomListView
	Private Panel1 As Panel
	Private titulo As Label
	
	' Ementa.bal
	Private ecrNome As Label
	Private ecrData As Label
	
	Private btnDown As Button
	Private btnUP As Button
	Private LogoRest As ImageView
	
	' eFibal.bal - ficha do prato
	Private efFoto As ImageView
	Private efNome As Label
	Private efObs As Label
	Private efPvp1 As Label
	Private efPvp2 As Label
	Private efPvp3 As Label
	Private efTit1 As Label
	Private efTit2 As Label
	Private efTit3 As Label
	
	Private LogBmp As Bitmap
	Private eNomeE As Label
	
	' Informação da empresa
	Private edObs As Label
	Private edWebSite As Label
	Private edEmail As Label
	Private edTel As Label
	Private edCPostal As Label
	Private edLoca As Label
	Private edMorada As Label
	Private edNome As Label
	' Controlo de ter mostrado as sugestões
	Private bMostrouSugestoes As Boolean
	
	' Ecrã das sugestões
	Private clvSug As CustomListView
	Private Label1 As Label
	
	Private ivChefe As ImageView
	
	Private esObs As Label
	Private esPrato As Label

	Private btnUPp As Button
	Private btnDownp As Button

	' MENU
	Private btOp3 As Button
	Private btOp2 As Button
	Private btOp1 As Button
	
	Private pFR As Panel
	Private pUK As Panel
	Private pES As Panel
	Private pPT As Panel

	Private btMenu As Button
	Private ivPais As ImageView
	Private ivPT As ImageView
	Private ivUK As ImageView
	Private ivFR As ImageView
	Private ivES As ImageView

	Private pIdiomaSeg As Panel
	Private ivsPT As ImageView
	Private ivsUK As ImageView
	Private ivsFR As ImageView
	Private ivsES As ImageView
	Private lblChefe As Label
	Private IdiomaSug As Int
	Private bDialogOpen As Boolean

	Private pLin As Panel
	Private pGrn As Panel

	Private lblOpen As Label
	Private pN1 As Panel
	Private CLV2 As CustomListView
	Private tN1 As Label
	Private pN0 As Panel
	Private GrImg As ImageView
	
	Private pN3 As Panel
	Private pN2 As Panel
	Private CLV3 As CustomListView
	Private CLV4 As CustomListView
	Private tN3 As Label
	Private tN2 As Label
	Private pExit As Panel
	Private esImg As ImageView
	Private lMsgDir As Label
	Private lMsgEsq As Label
	Private btOp4 As Button
	Private imgBIG As ImageView
	Private nomeBIG As Label
	Private obsBIG As Label
End Sub

Sub Activity_Create(FirstTime As Boolean)

	'Do not forget to load the layout file created with the visual designer. For example:
	Drawer.Initialize(Me, "Drawer", Activity, 75%x)
	Drawer.CenterPanel.LoadLayout("Elastico")
	Drawer.LeftPanel.LoadLayout("emMenu")
	
	Dim Bt(4) As Button
	
	' Desligar os paineis de apoio
	pN3.SetVisibleAnimated(400,False)
	pN2.SetVisibleAnimated(400,False)
	pN1.SetVisibleAnimated(400,False)
	pN0.SetVisibleAnimated(400,True)
	
	' 
	pN1.Color = Colors.LightGray
	pN2.Color = Colors.LightGray
	pN3.Color = Colors.LightGray
		
	bStopPulsar =False

	PulsarWork
	
	' Preparar o cabeçalho da ementa c/ a colocação do logotipo
	' do restaurante seleccionado
	If Starter.Restaurante.usaLogo = True Then
		Try
			Dim LogBmp As Bitmap  = RB.CreateBitmap( Starter.Restaurante.LogoTipo)
	
			LogoRest.Bitmap = LogBmp
	
			LogoRest.Visible =True
		Catch
			Log(LastException)
		End Try
	Else
		LogoRest.Visible=False
		ecrNome.Left = LogoRest.Left
	End If
	
	Dim nCartas As Int = 1
	' Dados da empresa/restaurante
	ecrNome.Text = Starter.Restaurante.Nome
	ecrData.Text = Starter.Restaurante.DataHoje
	' Roda pé
	lMsgEsq.Text = Starter.Restaurante.MsgEsq
	lMsgDir.Text = Starter.Restaurante.MsgDir


	btOp1.Visible =True
	' ex-Ementa
	btOp1.Text = Starter.Restaurante.Carta(0)
	btOp1.Tag = 0
	' Outros botões estão invisiveis
	btOp2.Visible = False
	btOp3.Visible = False
	btOp4.Visible = False
	
	Bt(0) = btOp1
	Bt(1) = btOp2
	Bt(2) = btOp3
	Bt(3) = btOp4
	
	For i = 1 To 3
		If Starter.Restaurante.UsaCarta(i) = True Then
			Bt(nCartas).Text = Starter.Restaurante.Carta(i)
			Bt(nCartas).Visible = True
			Bt(nCartas).Tag = i
			nCartas = nCartas + 1
		End If
	Next

	eNomeE.Text = Starter.Restaurante.NomeEmenta
	eNomeE.Tag = 0
	
	' Vamos começão pelos pratos
	Starter.Lista.Tipo = 0
	' vamos sinalizar que ainda não mostrou as sugestões
	bMostrouSugestoes = False
	
	dialog.Initialize(Activity)
	bDialogOpen = False
	' Sem idiomas
	pPT.Visible=False
	pFR.Visible=False
	pUK.Visible=False
	pES.Visible=False
	
	pN0.Visible =True
	pN1.Visible =False 
	
	Dim p As Panel = pPT
	
	If ( Starter.Restaurante.UK Or Starter.Restaurante.ES Or Starter.Restaurante.FR ) = True Then
		' Arrumar os botões para dar acesso aos menus em línguas
		' temos pelo menos um idioma
		pPT.Top = Bt(nCartas-1).Top + Bt(nCartas-1).Height + 5dip
		pPT.Visible = True
		
		If Starter.Restaurante.UK = True Then
			pUK.Visible = True
			pUK.Top = p.Top + p.Height + 5dip
			p =pUK
		End If
		If Starter.Restaurante.fr = True Then
			pFR.Visible = True
			pFR.Top = p.Top + p.Height + 5dip
			p = pFR
		End If
		If Starter.Restaurante.ES = True Then
			pES.Visible = True
			pES.Top = p.Top + p.Height + 5dip
			p = pES
		End If
	End If
	
	
	' TEMOS COLOCAR UM COMNADO SQL DE PESQUISA DA EMENTA
	Wait For (MostarEmenta) Complete (ListaOK As Boolean)
	If ListaOK = True Then
		bStopPulsar = True
	End If
	
End Sub

Private Sub CreateItemNivel(Width As Int, Item As ItemEmenta, idioma As Int) As ResumableSub
	Dim p As B4XView = xui.CreatePanel("")
	' GERAR O TAMANHO DO PAINEL
	
	Dim height As Int = 0
	' ALTURA DO NÍVEL
	Select Case Item.Nivel
		Case 1
			height = 110dip
		Case 2
			height = 100dip
		Case 3
			height = 90dip
	End Select
	
	p.SetLayoutAnimated(0, 0, 0, Width, height)
	' LAYPUT DE CADA NÍVEL
	Select Case Item.Nivel
		Case 1
			p.LoadLayout("elNivel1")
		Case 2
			p.LoadLayout("elNivel2")
		Case 3
			p.LoadLayout("elNivel3")
	End Select
	

	Select Case idioma
		Case 1
			titulo.Text = Item.UkDescLinha
		Case 2
			titulo.Text = Item.FRDescLinha
		Case 3
			titulo.Text = Item.ESObsLInha
		Case Else
			titulo.Text = Item.Nome
	End Select

	If titulo.Text.TRIM.Length	= 0 Then
		titulo.Text = Item.Nome
	End If

	If Item.Nivel = 1 Then
		
		If Item.UsaImagem Then
			GrImg.Visible = True
			' VAMOS VER SE JÁ A CARREGOU A IMAGEM
			If Item.LoadImg = False Then
			' CARREGA A IMAGEM...
				Wait For (Starter.GetImagem(Item)) Complete (LoadOk As Boolean)
				If LoadOk = True Then
					LogBmp = RB.CreateBitmap( Item.Imagem)
					Try
						GrImg.Bitmap = LogBmp
						GrImg.Visible = True
					Catch
						Log(LastException)
					End Try
				Else
					GrImg.Visible =False
				End If
			Else
				GrImg.Bitmap = RB.CreateBitmap( Item.Imagem)
			End If
		Else
			GrImg.Visible =False
		End If
		If GrImg.Visible = False Then
			titulo.Left = GrImg.Left
		End If
	End If
	
	lblOpen.Visible = True
	pGrn = P
	Return True
End Sub

Private Sub CreateLinha(Width As Int, Item As ItemEmenta, Idioma As Int) As ResumableSub
	
	Dim p As B4XView = xui.CreatePanel("")
	' GERAR O TAMANHO DO PAINEL
	Dim height As Int = 210dip
	Dim Reduz As Int
	
	' Calcular o tamanho e desenho
	Dim tmpObs As String
	Dim tmpNome As String
	Dim TmpBMP As Bitmap
	Dim bImagem As Boolean
	Select Case Idioma
		Case 1
			tmpNome = " " & Item.UkDescLinha
			tmpObs = Item.UKObsLinha
		Case 2
			tmpNome = " " & Item.FRDescLinha
			tmpObs = Item.FRObsLinha
		Case 3
			tmpNome = " " & Item.ESDescLinha
			tmpObs = Item.ESObsLInha
		Case Else
			tmpNome = " " & Item.Nome
			tmpObs = Item.Obs
	End Select
	
	If Starter.Restaurante.UsaImagens = False Then
		bImagem = False
	Else
		If Item.UsaImagem Then
			' VAMOS VER SE JÁ A CARREGOU
			If Item.LoadImg = False Then
				' CARREGA A IMAGEM...
				Wait For (Starter.GetImagem(Item)) Complete (ListaOk As Boolean)
			End If
			TmpBMP = RB.CreateBitmap( Item.Imagem)
			Try
				bImagem = True
			Catch
				Log(LastException)
				bImagem = False
			End Try
		Else
			bImagem =False
		End If
	End If
	' Já podemos calcular a altura
	Reduz = 0
	If bImagem = False Then
		' ? temos observações
		If tmpObs.Trim.Length > 0 Then
			Reduz = 40dip		
		Else
			Reduz = 80dip
		End If
	End If

	p.SetLayoutAnimated(0, 0, 0, Width, height - Reduz)
	p.LoadLayout("elFicha")
	

	If tmpNome.Trim.Length	= 0 Then
		tmpNome = Item.Nome
	End If

	If bImagem = True	Then
		Try
			efFoto.Bitmap = TmpBMP
		Catch
			Log(LastException)
			bImagem =False
		End Try
	End If
	efFoto.Visible = bImagem
	If bImagem  = False Then
		efObs.Left = efFoto.Left
		efObs.Height= efObs.Height - Reduz
		efObs.Width = efNome.Width
	End If
	
	efObs.Text = tmpObs
	efNome.Text = tmpNome
	If Reduz > 0 Then
		efTit1.Top = efTit1.Top - Reduz
		efTit2.Top = efTit2.Top - Reduz
		efTit3.Top = efTit3.Top - Reduz

		efPvp1.Top = efPvp1.Top - Reduz
		efPvp2.Top = efPvp2.Top - Reduz
		efPvp3.Top = efPvp3.Top - Reduz
	End If
	
	' PREENCHER OS DADOS
	efTit1.Text = Item.cab1
	efTit2.Text = Item.cab2
	efTit3.Text = Item.cab3
		
	efPvp1.Text = Item.pvp1
	efPvp2.Text = Item.pvp2
	efPvp3.Text = Item.pvp3

	pLin = p
	Return True
End Sub


Sub Activity_Resume

End Sub

Sub Activity_Pause (UserClosed As Boolean)

End Sub


Sub MostarEmenta() As ResumableSub
	Dim bResult As Boolean
	Dim bLoad As Boolean

	' FECHAR OS SINALIZADORES
	btnUP.Visible =False
	btnDown.Visible = False

	pN0.Enabled = False
	pN1.Enabled = False
	pN2.Enabled = False
	pN3.Enabled = False
	
	pN3.SetVisibleAnimated(400, False)
	pN2.SetVisibleAnimated(400, False)
	pN1.SetVisibleAnimated(400, False)
	pN0.SetVisibleAnimated(400, True)

	' Lista de apoio e se está carregada
	Starter.Lista.Apoio = Starter.Lista.Carta(Starter.Lista.Tipo)
	bLoad = Starter.Lista.CartaLoad(Starter.Lista.Tipo)
	
	' Ver o tamanho do menu
	Log(Starter.Lista.apoio.Size)
	
	bResult = False
	If bLoad = False Then
		Wait For (Starter.CarregarEmenta(True)) Complete (ListaOK As Boolean)
		' Marca lista como carregada
		Starter.Lista.CartaLoad(Starter.Lista.Tipo) = True
	End If


	Wait For (ListarEmenta) Complete (ListaOK As Boolean)
	bResult = ListaOK
	' Vamos Mostar as sugestões se necessário....
	If bMostrouSugestoes = False And Starter.Restaurante.SugestoesChefe = True Then
		' Mostrar as sugestões
		bStopPulsar = True
		Wait For (MostraSugestoes) Complete (ListaOK As Boolean)
		bMostrouSugestoes = True
	End If
	
	Log(bResult)
	pN0.Enabled =True
	pN1.Enabled =True
	pN2.Enabled =True
	pN3.Enabled =True
	Return bResult

End Sub


Sub MostraSugestoes()As ResumableSub
	' Listar as sugestoes
	Dim d As B4XView = xui.CreatePanel("")
	d.SetLayoutAnimated(0,5%x,15%y, 90%x, 70%y )
	d.LoadLayout("eSugChefe")
		
	dialog.PutAtTop = True
	dialog.BorderWidth = 2
	dialog.ButtonsHeight = 50dip
	dialog.ButtonsTextColor = xui.Color_White
		
	dialog.BorderColor = xui.Color_Black
	dialog.BackgroundColor = xui.Color_White
	
	' Português por defeito
	IdiomaSug =0
	If Starter.Restaurante.nLinguas = 1 Then
		pIdiomaSeg.Visible =False
	Else
		Dim iv As ImageView = ivsPT
		ivsPT.Visible =True
		lblChefe.Text = "Sugestões do Chefe"
		If Starter.Restaurante.UK = True Then
			ivsUK.Visible =True
			iv = ivsUK
		End If
		If Starter.Restaurante.fr = True Then
			ivsFR.Visible =True
			ivsFR.Left = iv.Left + iv.Width + 5
			iv = ivsFR
		End If
		If Starter.Restaurante.es = True Then
			ivsES.Visible =True
			ivsES.Left = iv.Left + iv.Width + 5
			iv = ivsES
		End If
		
	End If
	
	Try
		
		Do While clvSug.Size > 0
			clvSug.RemoveAt(0)
		Loop
	Catch
		Log(LastException)
	End Try
	
	ivChefe.Left = (d.Width - ivChefe.Width) / 2
	
	
	For i = 0 To Starter.Lista.Sugestoes.Size - 1
		' PERCORRER A LISTAS DE SUGESTÕES
		Dim xPrato As TypeSugestao
		xPrato = Starter.Lista.Sugestoes.Get(i)
		clvSug.Add(CreateItemSugestao(clvSug.AsView.Width, xPrato,IdiomaSug), xPrato)
	Next

	' MOSTRAR FICHA DO PRODUTO
	bDialogOpen = True
	Wait For (dialog.ShowCustom(d, "", "", "FECHAR")) Complete (Result As Int)
	bDialogOpen = False

	Return True
	
End Sub

Private Sub CreateItemSugestao(Width As Int, Item As TypeSugestao, idioma As Int) As Panel
	Dim p As B4XView = xui.CreatePanel("")
	' GERAR O TAMANHO DO PAINEL
	
	Dim height As Int = 105dip
	p.SetLayoutAnimated(0, 0, 0, Width, height)
	p.LoadLayout("esPratoImg")
	Select Case idioma
		Case 1
			esPrato.Text = Item.UkPrato
			esObs.Text = Item.UKObs
		Case 2
			esPrato.Text = Item.FRPrato
			esObs.Text = Item.FRObs
		Case 3
			esPrato.Text = Item.ESPrato
			esObs.Text = Item.ESObs
		Case Else
			esPrato.Text = Item.NomePrato
			esObs.Text = Item.Descritivo
	End Select
	If esPrato.Text.Trim.Length =0 Then
		esPrato.Text = Item.NomePrato
	End If
	
	If esObs.Text.Trim.Length =0 Then
		esObs.Text = Item.Descritivo
	End If
	
	If Item.UsaImagem = True Then
		' Foi previamente carregada
		LogBmp = RB.CreateBitmap( Item.Imagem)
		Try
			esImg.Bitmap = LogBmp
			esImg.Visible = True
		Catch
			Log(LastException)
			esImg.Bitmap = Null
			esImg.Visible = False
		End Try
	Else
		esImg.Visible =False
	End If
	
	If esImg.Visible = False Then
		esObs.Left = esImg.Left
	End If
	
	Return p
End Sub


Sub ListarEmenta () As ResumableSub
	
	Dim Item As ItemEmenta
	Dim Idioma As Int = Starter.Lista.idioma
	
	pN0.SetVisibleAnimated(400,True)
	pN1.SetVisibleAnimated(400,False)
		
	For i = 0 To Starter.Lista.Apoio.Size-1
		' ELEMENTO DO MENU
		Item = Starter.Lista.Apoio.Get(i)
		' GERAR NIVEL 1
		Select Case Item.Nivel
			Case 1
				wait for (CreateItemNivel(CLV1.AsView.Width, Item, Idioma) ) complete (Success As Boolean)
				If Success Then
					CLV1.add(pGrn, Item)
				End If
		End Select
	Next
	
	Return True

End Sub

' ==== Vamos avançar até ao nível 1
Sub CLV1_ItemClick (Index As Int, Value As Object)
	Dim Valor As ItemEmenta = Value
	Dim Item As ItemEmenta
	Dim Idioma As Int = Starter.Lista.idioma
	
	Dim go As Boolean = True
	Dim iPos As Int = Valor.Indice + 1
	Dim i As Int = iPos
	
	' BLOQUER OUTROS TOQUES
	pN0.Enabled =False

	bStopPulsar =False
	PulsarWork

	' TEMOS DE FAZER COISAS
	tN1.Text = Valor.Nome
	pN1.SetVisibleAnimated(400,True)
	pN0.SetVisibleAnimated(400,False)


	' Vamos limpar a clv2
	Do While CLV2.Size > 0 
		CLV2.RemoveAt(0)
	Loop

	' Criar a lista de elementos do nível 1	
	Do While go = True
		' ELEMENTO DO MENU
		Item = Starter.Lista.Apoio.Get(i)

		' Controlo de eventuais erros
		If Valor.Nivel <> 1 Then
			go = False
		Else
			If Item.id1 <> Valor.id1 Then
				' acabou
				go = False
			Else
				Select Case Item.Nivel
					Case 0
						If Item.id2 = 0 And Item.id3 = 0 Then
							wait for (CreateLinha(CLV2.AsView.Width, Item, Idioma) ) complete (Success As Boolean)
							If Success Then
								CLV2.add(pLin, Item)
							End If
						End If
					Case Else
						If Item.id3 = 0 Then
							wait for (CreateItemNivel(CLV2.AsView.Width, Item, Idioma) ) complete (Success As Boolean)
							If Success Then
								CLV2.add(pGrn, Item)
							End If
						End If
				End Select
			End If
				
		End If
		' Passar ao item seguinte
		i = i +1
		' Controlo de Chegada ao fim
		If i >= Starter.Lista.Apoio.Size Then
			go =False
		End If
		
	Loop
	bStopPulsar = True
	' LIBERAR OUTROS TOQUES
	pN0.Enabled = True
		
End Sub

' ================= Mamntemos o pulsar para podermos mudar as cores e frequência.....
Sub PulsarWork()
	CreateHaloEffect(Activity, Activity.Width/2, 2*Activity.Height/3, xui.Color_Gray)
	' Para parar este efeito colocar
	' bStopPulsar = false
End Sub

Sub CreateHaloEffect (Parent As B4XView, x As Int, y As Int, clr As Int)
	Dim cvs As B4XCanvas
	Dim p As B4XView = xui.CreatePanel("")
	Dim radius As Int = 150dip
	
	' ESPERA ORDEM DE TERMINAR
	Do While ( bStopPulsar = False )
		
		p.SetLayoutAnimated(0, 0, 0, radius * 2, radius * 2)
		cvs.Initialize(p)
		cvs.DrawCircle(cvs.TargetRect.CenterX, cvs.TargetRect.CenterY, cvs.TargetRect.Width / 2, clr, True, 0)
		Dim bmp As B4XBitmap = cvs.CreateBitmap
		For i = 1 To 5
			If bStopPulsar =True Then Exit
			' PONTO DE SAÍDA
			CreateHaloEffectHelper(Parent,bmp, x, y,  radius)
			' PONTO DE SAÍDA
			If bStopPulsar = False	Then Sleep(400)
		Next
		p.RemoveAllViews()
	Loop
End Sub

Sub CreateHaloEffectHelper (Parent As B4XView,bmp As B4XBitmap, x As Int, y As Int, radius As Int)
	Dim iv As ImageView
	iv.Initialize("")
	Dim p As B4XView = iv
	p.SetBitmap(bmp)
	Parent.AddView(p, x, y, 0, 0)
	Dim duration As Int = 1000
	
	p.SetLayoutAnimated(duration, x - radius, y - radius, 2 * radius, 2 * radius)
	p.SetVisibleAnimated(duration, False)
	' PONTO DE SAÍDA
	If bStopPulsar = False	Then Sleep(duration)
	
	p.RemoveViewFromParent
End Sub

Sub CLV1_ReachEnd
	' VIMOS O ÚLTIMA LINHA
	btnDown.Visible = False
End Sub

Sub CLV1_VisibleRangeChanged (FirstIndex As Int, LastIndex As Int)
	Dim nLista As Int = CLV1.Size -1	
	' mudou a a área visível...
	If LastIndex < nLista Then
		btnDown.Visible =True
	Else
		btnDown.Visible = False
	End If

	' ESTÁ TOPO
	If FirstIndex > 0 Then
		btnUP.Visible =True
	Else
		btnUP.Visible =False
	End If
	If LastIndex >= CLV1.Size Then
		btnDown.Visible =False
	End If
End Sub

Sub LogoRest_Click
	' Mostra os dados da empresa
	
	Dim d As B4XView = xui.CreatePanel("")
		
	d.SetLayoutAnimated(0,10%x,50dip, 80%x, 300dip)
	d.LoadLayout("eDadosEmp")
		
	dialog.PutAtTop = True
	dialog.BorderWidth = 2
	dialog.ButtonsHeight = 50dip
	dialog.ButtonsTextColor = xui.Color_White
		
	dialog.BorderColor = xui.Color_Black
	dialog.BackgroundColor = xui.Color_Transparent
	
	' PREENCHER OS DADOS
	edNome.Text = Starter.Restaurante.Nome
	edMorada.Text = Starter.Restaurante.Morada
	edLoca.Text = Starter.Restaurante.Localidade
	edCPostal.Text = Starter.Restaurante.CPostal
	edTel.Text = Starter.Restaurante.Telefones
	edEmail.Text = Starter.Restaurante.Email
	edWebSite.Text = Starter.Restaurante.website
	edObs.Text = Starter.Restaurante.Obs

	' MOSTRAR FICHA DO A EMPRESA
	bDialogOpen = True
	Wait For (dialog.ShowCustom(d, "", "", "FECHAR")) Complete (Result As Int)
	bDialogOpen = False
	
End Sub

Sub clvSug_VisibleRangeChanged (FirstIndex As Int, LastIndex As Int)
	' mudou a a área visível...
	Dim nMaxLinha As Int = clvSug.Size - 1
	If LastIndex < nMaxLinha Then
		btnDownp.Visible =True
	Else
		btnDownp.Visible = False
	End If
	' ESTÁ TOPO
	If FirstIndex > 0 Then
		btnUPp.Visible =True
	Else
		btnUPp.Visible =False
	End If

End Sub

Sub clvSug_ReachEnd
	' VIMOS O ÚLTIMA LINHA
	btnDownp.Visible = False
End Sub

Sub btOP_Click()
	Dim bt As Button = Sender
	Dim iBtOrigem As Int = bt.Tag

	' Colocar as coisas no local
	pN3.SetVisibleAnimated(400,False)
	pN2.SetVisibleAnimated(400,False)
	pN1.SetVisibleAnimated(400,False)
	pN0.SetVisibleAnimated(400,True)

	eNomeE.Text = Starter.Restaurante.Carta(iBtOrigem)
	Starter.Lista.Tipo = iBtOrigem
	
	bStopPulsar	= False
	PulsarWork

	Do While CLV1.Size >0
		CLV1.RemoveAt(0)
	Loop
	
	Drawer.LeftOpen = False
	
	Wait For (MostarEmenta) Complete (ListaOK As Boolean)
	If ListaOK = True Then
		bStopPulsar = True
	End If

	bt.Enabled =True
	
	
End Sub

Sub pIdioma_Click
	' mudança de idioma

	Dim x As Object = Sender
	Dim pais As String  = ""
	Dim idioma As Int = 0

	' Colocar as coisas no local
	' Desligar os paineis de apoio
	pN3.SetVisibleAnimated(400,False)
	pN2.SetVisibleAnimated(400,False)
	pN1.SetVisibleAnimated(400,False)
	pN0.SetVisibleAnimated(400,True)
	
	Try
		If	GetType(x) = "Button" Then
			Dim bt As Button = Sender
			pais = bt.tag
		else if GetType(x) = "ImageView" Then
			Dim Iv As Button = Sender
			pais = Iv.tag
		Else
			Dim lb As Label = Sender
			pais = lb.tag
		End If
		
	Catch
		Log(LastException)
	End Try
	
	' dados válidos ?
	If pais.Length= 2 Then
		Drawer.LeftOpen =False

		bStopPulsar	= False
		PulsarWork
		Select Case pais.ToUpperCase
			Case "UK"
				idioma = 1
				ivPais.Bitmap = ivUK.Bitmap
			Case "FR"
				idioma = 2
				ivPais.Bitmap = ivFR.Bitmap
			Case "ES"
				idioma = 3
				ivPais.Bitmap = ivES.Bitmap
			Case Else
				idioma = 0
				ivPais.Bitmap = ivPT.Bitmap
		End Select
		
		
		Starter.Lista.idioma =idioma
		

		Do While CLV1.Size >0
			CLV1.RemoveAt(0)
		Loop
		
		Drawer.LeftOpen =False
		
		Wait For (MostarEmenta) Complete (ListaOK As Boolean)
		If ListaOK = True Then
			bStopPulsar = True
		End If
	Else
		' PEDIDO DE SAIDA
		Activity.Finish
	End If
End Sub

Sub btMenu_Click
	'ok
	Drawer.LeftOpen = True
End Sub

Sub Activity_KeyPress (KeyCode As Int) As Boolean
	' ok
	If KeyCode = KeyCodes.KEYCODE_BACK Then
		If Drawer.LeftOpen = True Then
			Drawer.LeftOpen = False
			Return True
		ELSE  IF bDialogOpen = True Then
			dialog.Close(0)
			bDialogOpen = False
			Return True
		Else if pN3.Visible Then
			
			pN3.SetVisibleAnimated(400,False)
			
			
			Return True
		Else if pN2.Visible Then
			
			pN3.SetVisibleAnimated(400,False)
			pN2.SetVisibleAnimated(400,False)
			
			
			Return True
		Else if pN1.Visible Then
			
			pN3.SetVisibleAnimated(400,False)
			pN2.SetVisibleAnimated(400,False)
			pN1.SetVisibleAnimated(400,False)
			pN0.SetVisibleAnimated(400,True)
			
			
			Return True
		Else
			Drawer.LeftOpen = True
			Return True
		End If
	End If
	Return False
End Sub


Sub ivPais_Click
	' ok
	Drawer.LeftOpen = True
End Sub

Sub isvSug_Click
	' OK
	Dim x As ImageView = Sender
	
	Dim Pais As String = x.Tag
	
	Try
		
		Do While clvSug.Size > 0
			clvSug.RemoveAt(0)
		Loop
	Catch
		Log(LastException)
	End Try
	
	Select Case Pais.ToUpperCase.Trim
		Case "PT"
			lblChefe.Text = "Sugestões do Chefe"
			IdiomaSug =0
		Case "UK"
			lblChefe.Text = "Chef's Suggestions"
			IdiomaSug =1
		Case "FR"
			lblChefe.Text = "Suggestions du chef"
			IdiomaSug =2
		Case "ES"
			lblChefe.Text = "Sugerencias del chef"
			IdiomaSug =3
						
	End Select
	
	For i = 0 To Starter.Lista.Sugestoes.Size - 1
		' PERCORRER A LISTAS DE SUGESTÕES
		Dim xPrato As TypeSugestao
		xPrato = Starter.Lista.Sugestoes.Get(i)
		clvSug.Add(CreateItemSugestao(clvSug.AsView.Width, xPrato,IdiomaSug), xPrato)
	Next

End Sub

Sub btnUPp_Click
	Try
		clvSug.ScrollToItem(1)
	Catch
		Log(LastException)
	End Try
End Sub

Sub btnDownp_Click
	Try
		clvSug.ScrollToItem(clvSug.Size-1)
	Catch
		Log(LastException)
	End Try
End Sub

Sub btnDown_Click
	Try
		CLV1.ScrollToItem(clvSug.Size-1)
	Catch
		Log(LastException)
	End Try
End Sub

Sub btnUP_Click
	Try
		CLV1.ScrollToItem(1)
	Catch
		Log(LastException)
	End Try
End Sub


Sub tN1_Click
	' REGRA AO NIVEL 0
	pN3.SetVisibleAnimated(400,False)
	pN2.SetVisibleAnimated(400,False)
	pN1.SetVisibleAnimated(400,False)
	pN0.SetVisibleAnimated(400,True)
	CLV1.Refresh
End Sub

Sub tN2_Click
	' REGRA AO NIVEL 0
	pN3.SetVisibleAnimated(400,False)
	pN2.SetVisibleAnimated(400,False)
	CLV2.Refresh
End Sub

Sub tN3_Click
	' REGRA AO NIVEL 0
	pN3.SetVisibleAnimated(400,False)
	CLV3.Refresh
End Sub

' ==== ESTAMOS NO NIVEL 2 =================
Sub CLV2_ItemClick (Index As Int, Value As Object)
	
	Dim Valor As ItemEmenta = Value
	Dim Item As ItemEmenta
	Dim Idioma As Int = Starter.Lista.idioma
	
	Dim go As Boolean = True
	Dim iPos As Int = Valor.Indice + 1
	Dim i As Int = iPos
	
	If Valor.Nivel = 0 Then
		' MOSTAR A FIGURA DESTE ITEM
		If Valor.UsaImagem = True Then
			MostraFichaBIG (Valor)
		End If
	Else

		' Bloquear 2º toques
		pN1.Enabled =False
		
		bStopPulsar =False
		PulsarWork

		' TEMOS DE FAZER COISAS
		tN2.Text = Valor.Nome
		pN2.SetVisibleAnimated(400,True)


		' Vamos limpar a clv2
		Do While CLV3.Size > 0
			CLV3.RemoveAt(0)
		Loop

		' Criar a lista de elementos do nível 1
		Do While go = True
			' ELEMENTO DO MENU
			Item = Starter.Lista.Apoio.Get(i)

			' Controlo de eventuais erros
			If Valor.Nivel <> 2 Then
				go = False
			Else
				If Item.id1 <> Valor.id1 Or Item.id2 <> Valor.id2 Then
					' acabou ( mudou de grupo)
					go = False
				Else
					Select Case Item.Nivel
						Case 0
							If Item.id3 = 0 Then
								wait for (CreateLinha(CLV3.AsView.Width, Item, Idioma) ) complete (Success As Boolean)
								If Success Then
									CLV3.add(pLin, Item)
								End If
							End If
						Case Else
							wait for (CreateItemNivel(CLV3.AsView.Width, Item, Idioma) ) complete (Success As Boolean)
							If Success Then
								CLV3.add(pGrn, Item)
							End If
					End Select
				End If
					
			End If
			' Passar ao item seguinte
			i = i +1
			' Controlo de Chegada ao fim
			If i >= Starter.Lista.Apoio.Size Then
				go =False
			End If
			
		Loop
		bStopPulsar = True
		' Bloquear 2º toques
		pN1.Enabled = True
	End If

End Sub

Sub CLV2_ReachEnd
	' VIMOS O ÚLTIMA LINHA
	btnDown.Visible = False
End Sub

Sub CLV2_VisibleRangeChanged (FirstIndex As Int, LastIndex As Int)
	' mudou a a área visível...
	Dim nMaxLista As Int = CLV2.Size-1
	
	If LastIndex < nMaxLista Then
		btnDown.Visible =True
	Else
		btnDown.Visible = False
	End If
	' ESTÁ TOPO
	If FirstIndex > 0 Then
		btnUP.Visible =True
	Else
		btnUP.Visible =False
	End If
	
End Sub

Sub CLV3_ItemClick (Index As Int, Value As Object)
	Dim Valor As ItemEmenta = Value
	Dim Item As ItemEmenta
	Dim Idioma As Int = Starter.Lista.idioma
	
	Dim go As Boolean = True
	Dim iPos As Int = Valor.Indice + 1
	Dim i As Int = iPos
	
	If Valor.Nivel = 0 Then
		' MOSTAR A FIGURA DESTE ITEM
		If Valor.UsaImagem = True Then
			MostraFichaBIG (Valor)
		End If
	Else

		pN2.Enabled = False
		
		bStopPulsar =False
		PulsarWork

		' TEMOS DE FAZER COISAS
		tN3.Text = Valor.Nome
		pN3.SetVisibleAnimated(400,True)


		' Vamos limpar a clv2
		Do While CLV4.Size > 0
			CLV4.RemoveAt(0)
		Loop

		' Criar a lista de elementos do nível 1
		Do While go = True
			' ELEMENTO DO MENU
			Item = Starter.Lista.Apoio.Get(i)

			' Controlo de eventuais erros
			If Valor.Nivel <> 3 Then
				go = False
			Else
				If Item.id1 <> Valor.id1 Or Item.id2 <> Valor.id2 Or Item.id3 <> Valor.id3 Then
					' acabou ( mudou de grupo)
					go = False
				Else
					If Item.Nivel = 0 Then
						wait for (CreateLinha(CLV4.AsView.Width, Item, Idioma) ) complete (Success As Boolean)
						If Success Then
							CLV4.add(pLin, Item)
						End If
					End If
				End If
					
			End If
			' Passar ao item seguinte
			i = i +1
			' Controlo de Chegada ao fim
			If i >= Starter.Lista.Apoio.Size Then
				go =False
			End If
			
		Loop
		bStopPulsar = True
		' Liberta sub-menu
		pN2.Enabled = True
	End If
End Sub

Sub CLV3_ReachEnd
	' VIMOS O ÚLTIMA LINHA
	btnDown.Visible = False
End Sub

Sub CLV3_VisibleRangeChanged (FirstIndex As Int, LastIndex As Int)
	' mudou a a área visível...
	Dim nMaxLinha As Int = CLV3.Size - 1
	
	If LastIndex < nMaxLinha Then
		btnDown.Visible =True
	Else
		btnDown.Visible = False
	End If
	' ESTÁ TOPO
	If FirstIndex > 0 Then
		btnUP.Visible =True
	Else
		btnUP.Visible =False
	End If
End Sub

Sub CLV4_ReachEnd
	' VIMOS O ÚLTIMA LINHA
	btnDown.Visible = False
End Sub

Sub CLV4_VisibleRangeChanged (FirstIndex As Int, LastIndex As Int)
	' mudou a a área visível...
	Dim nMaxLinha As Int = CLV4.Size - 1
	
	If LastIndex < nMaxLinha Then
		btnDown.Visible =True
	Else
		btnDown.Visible = False
	End If
	' ESTÁ TOPO
	If FirstIndex > 0 Then
		btnUP.Visible =True
	Else
		btnUP.Visible =False
	End If

End Sub


Sub CLV4_ItemClick (Index As Int, Value As Object)
	Dim Valor As ItemEmenta = Value
	' MOSTAR A FIGURA DESTE ITEM
	If Valor.UsaImagem = True Then
		MostraFichaBIG (Valor)
	End If
End Sub


Sub MostraFichaBIG ( Item As ItemEmenta) As ResumableSub
	
	' Listar as sugestoes
	Dim d As B4XView = xui.CreatePanel("")
	d.SetLayoutAnimated(0,5%x,5%y, 90%x, 90%y )
	d.LoadLayout("eBigImg")
		
	dialog.PutAtTop = True
	dialog.BorderWidth = 2
	dialog.ButtonsHeight = 50dip
	dialog.ButtonsTextColor = xui.Color_White
		
	dialog.BorderColor = xui.Color_Black
	dialog.BackgroundColor = xui.Color_White
	
	Try
		
		Dim ImgBmp As Bitmap = RB.CreateBitmap( Item.Imagem)
		imgBIG.Bitmap = ImgBmp	
		nomeBIG.Text = Item.Nome
		obsBIG.Text = Item.Obs
		
		imgBIG.Width = nomeBIG.Width
		imgBIG.Height = nomeBIG.Width
		imgBIG.Left = nomeBIG.Left
		
		obsBIG.Left = imgBIG.Left
		obsBIG.Width = imgBIG.Width
		obsBIG.Top = imgBIG.Top + imgBIG.Height + 2dip
		obsBIG.Height = Panel1.Height - obsBIG.Top
		
		' MOSTRAR FICHA DO PRODUTO
		bDialogOpen = True
		Wait For (dialog.ShowCustom(d, "", "", "FECHAR")) Complete (Result As Int)
		bDialogOpen =False

	Catch
		Log(LastException)
		Return False
	End Try
	
	
	
	
	Return True	
End Sub