﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Activity
Version=9.801
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: False
	#IncludeTitle: True
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	Type Operacao ( Id As Int, NumTrab As Int, Tarefa As String, Estado As Int)
End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.
	Private xui As XUI
	Private dialog As B4XDialog
	Private bStopPulsar As Boolean
	
	Private Drawer As B4XDrawer

	Private xui As XUI

	Private emImg As ImageView
	Private clvMenu As CustomListView
	Private btMenu As Button
	
	' Código de Acesso
	Private lblTitMenu As Label
	Private eEcrNome As Label
	Private eNomeS As Label
	Private eTarefa As Label
	Private eNum As Label
	Private CLV1 As CustomListView
	Private eFundo As Panel
	Private eOperacao As Label
	Private opGo As RadioButton
	Private opStop As RadioButton
	Private eTrab As Label
End Sub

Sub Activity_Create(FirstTime As Boolean)
	' activar o Drawer
	Drawer.Initialize(Me, "Drawer", Activity, 300dip)
	Drawer.CenterPanel.LoadLayout("eLista")
	Drawer.LeftPanel.LoadLayout("eMenu")
	
	eEcrNome.Text = Main.AppName

	' carregar o logo da App no «floater»
	emImg.Bitmap = xui.LoadBitmapResize(File.DirAssets,"logo_ltd.jpg",emImg.Width,emImg.Height,False)
	lblTitMenu.Text = "Escolher secção..."
	
	bStopPulsar = True
	
	eNomeS.Text = "02 - Esquelética"
	
	Dim nTrab As Int
	Dim sTrab As String
	
	For i = 1 To 30
		
		nTrab = 2345 + i
		sTrab = "TAREFA A EXECUTAR Nº" & i
		
		Dim oTarefa As Operacao
		
		oTarefa.Initialize
		oTarefa.Id = 0
		oTarefa.Tarefa = sTrab
		oTarefa.NumTrab = nTrab
		
		CLV1.Add(CreateLinha(CLV1.AsView.Width, oTarefa ),oTarefa)
		
	Next
	
	' Iniciar so dialogos que vão ser usados
	dialog.Initialize(Activity)

		
End Sub

Private Sub CreateLinha(Width As Int, oT As Operacao) As Panel
	
	Dim p As B4XView = xui.CreatePanel("")
	' GERAR O TAMANHO DO PAINEL
	Dim height As Int = 40dip
	
	p.SetLayoutAnimated(0, 0, 0, Width, height)
	p.LoadLayout("eTrab")
	
	eNum.Text = oT.NumTrab
	
	eTarefa.Text = oT.Tarefa
	If oT.Estado = 1 Then
		eFundo.SetColorAnimated(200, Colors.White,Colors.Yellow)
	Else
		eFundo.SetColorAnimated(200,Colors.Yellow,Colors.White)
	End If		
		
	Return p
End Sub

Sub Activity_Resume

End Sub

Sub Activity_Pause (UserClosed As Boolean)

End Sub


Sub btOk_Click
	' Preencher o código a procurar
	
end  Sub


Sub btCancel_Click
	Activity.Finish
End Sub

' === PULSAR 
Sub PulsarWork()
	CreateHaloEffect(Activity, Activity.Width/2, 2*Activity.Height/3, xui.Color_Gray)
	' Para parar este efeito colocar
	' bStopPulsar = false
End Sub

Sub CreateHaloEffect (Parent As B4XView, x As Int, y As Int, clr As Int)
	Dim cvs As B4XCanvas
	Dim p As B4XView = xui.CreatePanel("")
	Dim radius As Int = 150dip
	
	' ESPERA ORDEM DE TERMINAR
	Do While ( bStopPulsar = False )
		
		p.SetLayoutAnimated(0, 0, 0, radius * 2, radius * 2)
		cvs.Initialize(p)
		cvs.DrawCircle(cvs.TargetRect.CenterX, cvs.TargetRect.CenterY, cvs.TargetRect.Width / 2, clr, True, 0)
		Dim bmp As B4XBitmap = cvs.CreateBitmap
		For i = 1 To 5
			If bStopPulsar =True Then Exit
			' PONTO DE SAÍDA
			CreateHaloEffectHelper(Parent,bmp, x, y,  radius)
			' PONTO DE SAÍDA
			If bStopPulsar = False	Then Sleep(800)
		Next
		p.RemoveAllViews()
	Loop
End Sub

Sub CreateHaloEffectHelper (Parent As B4XView,bmp As B4XBitmap, x As Int, y As Int, radius As Int)
	Dim iv As ImageView
	iv.Initialize("")
	Dim p As B4XView = iv
	p.SetBitmap(bmp)
	Parent.AddView(p, x, y, 0, 0)
	Dim duration As Int = 3000
	
	p.SetLayoutAnimated(duration, x - radius, y - radius, 2 * radius, 2 * radius)
	p.SetVisibleAnimated(duration, False)
	' PONTO DE SAÍDA
	If bStopPulsar = False	Then Sleep(duration)
	
	p.RemoveViewFromParent
End Sub

Sub Activity_KeyPress (KeyCode As Int) As Boolean
	If KeyCode = KeyCodes.KEYCODE_BACK And Drawer.LeftOpen Then
		Drawer.LeftOpen = False
		Return True
	End If
	Return False
End Sub


Sub btMenu_Click
	
	Drawer.LeftOpen = True
	
End Sub


Sub CLV1_ItemClick (Index As Int, Value As Object)
	Dim oT As Operacao = Value
	
	
	If oT.Estado = 0 Then
		' MANDAR A ARRANCAR A TAREFA
		Wait For ( PedirConfirmacao (oT) ) Complete	(Result As Int)
		If Result = DialogResponse.POSITIVE Then
			oT.Estado = 1
	
			Dim p As Panel = CreateLinha(CLV1.AsView.Width, oT)

			CLV1.ReplaceAt(Index, p, p.Height, oT)
		
		End If
		
	Else
		' FINALIZAR AS TAREFA
		Wait For ( PedirConclusao (oT) ) Complete	(Result As Int)
		If Result = DialogResponse.POSITIVE Then
			oT.Estado = 2
	
			CLV1.RemoveAt(Index)
		
		End If
	End If
	

	
	
End Sub

Sub PedirConfirmacao ( oT As Operacao) As ResumableSub
	
	Dim d As B4XView = xui.CreatePanel("")
	
	d.SetLayoutAnimated(0,10%x, 50dip, 80%x, 220dip)
	d.LoadLayout("einiciar")
	
	dialog.PutAtTop = True
	dialog.BorderWidth = 3
	dialog.ButtonsHeight = 50dip
	dialog.ButtonsTextColor = xui.Color_Black
	dialog.ButtonsColor = xui.Color_Gray
	
	dialog.BorderColor = xui.Color_Blue
	dialog.BackgroundColor = xui.Color_White
	
	eTrab.Text = oT.NumTrab
	eOperacao.Text = oT.Tarefa
		
	Wait For (dialog.ShowCustom(d, "INICIAR", "", "CANCELAR")) Complete (Result As Int)
	
	Return Result

End Sub

Sub PedirConclusao ( oT As Operacao) As ResumableSub
	
	Dim d As B4XView = xui.CreatePanel("")
	
	d.SetLayoutAnimated(0,10%x, 50dip, 80%x, 220dip)
	d.LoadLayout("efinalizar")
	
	dialog.PutAtTop = True
	dialog.BorderWidth = 3
	dialog.ButtonsHeight = 50dip
	dialog.ButtonsTextColor = xui.Color_Black
	dialog.ButtonsColor = xui.Color_Gray
	
	dialog.BorderColor = xui.Color_Blue
	dialog.BackgroundColor = xui.Color_White
	
	opGo.Checked=True
	opStop.Checked = False
	eTrab.Text = oT.NumTrab
	eOperacao.Text = oT.Tarefa
		
	Wait For (dialog.ShowCustom(d, "CONCLUIR", "", "CANCELAR")) Complete (Result As Int)
	
	Return Result

End Sub


Sub opStop_CheckedChange(Checked As Boolean)
	opGo.Checked =Not ( Checked )
End Sub

Sub opGo_CheckedChange(Checked As Boolean)
	opStop.Checked =Not ( Checked )
End Sub