﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Activity
Version=9.801
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: False
	#IncludeTitle: True
#End Region

Sub Process_Globals
	Private xui As XUI

End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.

	Private dialog As B4XDialog
	Private bStopPulsar As Boolean
	Private Drawer As B4XDrawer

	Private CLV1 As CustomListView
	Private Col1 As Label
	Private Col2 As Label
	Private Col3 As Label
	Private Panel1 As Panel
	Private titulo As Label
	Private pnLine As Panel
	Private prato As Label
	Private pvp1 As Label
	Private pvp2 As Label
	Private pvp3 As Label
	
	' Ementa.bal
	Private ecrNome As Label
	Private ecrData As Label
	
	Private btnDown As Button
	Private btnUP As Button
	Private LogoRest As ImageView
	
	' eFibal.bal - ficha do prato
	Private efFoto As ImageView
	Private efNome As Label
	Private efObs As Label
	Private efPvp1 As Label
	Private efPvp2 As Label
	Private efPvp3 As Label
	Private efTit1 As Label
	Private efTit2 As Label
	Private efTit3 As Label
	
	Dim LogBmp As Bitmap
	Private eNomeE As Label
	
	Private GrImg As ImageView
	Private Grtitulo As Label
	Private prG1 As Panel

	' Informação da empresa
	Private edObs As Label
	Private edWebSite As Label
	Private edEmail As Label
	Private edTel As Label
	Private edCPostal As Label
	Private edLoca As Label
	Private edMorada As Label
	Private edNome As Label
	' Controlo de ter mostrado as sugestões
	Private bMostrouSugestoes As Boolean
	
	' Ecrã das sugestões
	Private clvSug As CustomListView
	Private Label1 As Label
	
	Private ivChefe As ImageView
	
	Private esObs As Label
	Private esPrato As Label
	Private pES As Panel
	Private lES As Label
	Private ivES As ImageView
	Private ivFR As ImageView
	Private lFR As Label
	Private pFR As Panel
	Private pUK As Panel
	Private lUK As Label
	Private ivUK As ImageView
	Private ivPT As ImageView
	Private lPT As Label
	Private pPT As Panel
	Private btOp3 As Button
	Private btOp2 As Button
	Private btOp1 As Button
	Private btMenu As Button
	Private lblChefe As Label
	Private IdiomaSug As Int

	Private ivsES As ImageView
	Private ivsFR As ImageView
	Private ivsUK As ImageView
	Private ivsPT As ImageView
	Private pIdiomaSeg As Panel
	Private ivPais As ImageView
	Private colorP As Int
	Private bDialogOpen As Boolean
	
	Private btnUPp As Button
	Private btnDownp As Button
	Private lMsgEsq As Label
	Private lMsgDir As Label
	Private btOp4 As Button
End Sub

Sub Activity_Create(FirstTime As Boolean)

	'Do not forget to load the layout file created with the visual designer. For example:
	Drawer.Initialize(Me, "Drawer", Activity, 75%x)
	Drawer.CenterPanel.LoadLayout("Escada")
	Drawer.LeftPanel.LoadLayout("emMenu")

	' colocar a cor
	colorP = Colors.RGB(104,62,62)
	
	Dim Bt(4) As Button
	
	Drawer.LeftPanel.SetColorAndBorder(colorP,1dip,colorP,1dip)
	bStopPulsar =False

	PulsarWork
	
	' Preparar o cabeçalho da ementa c/ a colocação do logotipo
	' do restaurante seleccionado
	If Starter.Restaurante.usaLogo = True Then
		Try
			Dim LogBmp As Bitmap  = RB.CreateBitmap( Starter.Restaurante.LogoTipo)
	
			LogoRest.Bitmap = LogBmp
	
			LogoRest.Visible =True
		Catch
			Log(LastException)
		End Try
	Else
		LogoRest.Visible=False
		ecrNome.Left = LogoRest.Left
	End If
	
	Dim nCartas As Int = 1
	' Dados da empresa/restaurante
	ecrNome.Text = Starter.Restaurante.Nome
	ecrData.Text = Starter.Restaurante.DataHoje
	
	' Roda pé
	lMsgEsq.Text = Starter.Restaurante.MsgEsq
	lMsgDir.Text = Starter.Restaurante.MsgDir
	
	btOp1.Visible =True
	' ex-Ementa
	btOp1.Text = Starter.Restaurante.Carta(0)
	btOp1.Tag = 0
	' Outros botões estão invisiveis
	btOp2.Visible = False
	btOp3.Visible = False
	btOp4.Visible = False
	
	Bt(0) = btOp1
	Bt(1) = btOp2
	Bt(2) = btOp3
	Bt(3) = btOp4
	
	For i = 1 To 3
		If Starter.Restaurante.UsaCarta(i) = True Then
			Bt(nCartas).Text = Starter.Restaurante.Carta(i)
			Bt(nCartas).Visible = True
			Bt(nCartas).Tag = i
			nCartas = nCartas + 1
		End If
	Next

	eNomeE.Text = Starter.Restaurante.NomeEmenta
	eNomeE.Tag = 0
	
	' Vamos começão pelos pratos
	Starter.Lista.Tipo = 0
	' vamos sinalizar que ainda não mostrou as sugestões
	bMostrouSugestoes = False
	
	dialog.Initialize(Activity)
	bDialogOpen =False
	' Sem idiomas
	pPT.Visible=False
	pFR.Visible=False
	pUK.Visible=False
	pES.Visible=False
	If ( Starter.Restaurante.UK Or Starter.Restaurante.ES Or Starter.Restaurante.FR ) = True Then
		' Arrumar os botões para dar acesso aos menus em línguas
		' temos pelo menos um idioma
		Dim p As Panel
		
		pPT.Top = Bt(nCartas-1).Top + Bt(nCartas-1).Height + 5dip
		pPT.Visible = True
		
		p =pPT
		If Starter.Restaurante.UK = True Then
			pUK.Visible = True
			pUK.Top = p.Top + p.Height + 5dip
			p =pUK
		End If
		If Starter.Restaurante.fr = True Then
			pFR.Visible = True
			pFR.Top = p.Top + p.Height + 5dip
			p = pFR
		End If
		If Starter.Restaurante.ES = True Then
			pES.Visible = True
			pES.Top = p.Top + p.Height + 5dip
			p = pES
		End If
	End If
	
	' TEMOS COLOCAR UM COMNADO SQL DE PESQUISA DA EMENTA
	Wait For (MostarEmenta) Complete (ListaOK As Boolean)
	If ListaOK = True Then
		bStopPulsar = True
	End If
	

End Sub

Private Sub CreateItemTop(Width As Int, Item As ItemEmenta) As ResumableSub
	
	Dim p As B4XView = xui.CreatePanel("")
	' GERAR O TAMANHO DO PAINEL
	
	Dim height As Int = 0
	' ALTURA DO NÍVEL
	If Starter.Restaurante.UsaImagens = False Then
		height = 80dip
	Else
		height = 150dip
	End If
	p.SetLayoutAnimated(0, 0, 0, Width, height)
	p.LoadLayout("eEscadaN1")
	
	' LAYPUT DE CADA NÍVEL
	If Starter.Restaurante.UsaImagens = False Then
		' Temos de ajustar o posicionamento das labels
		Col1.Top = 40dip
		Col2.Top = 40dip
		Col3.Top = 40dip
		Grtitulo.Left = GrImg.Left
		Grtitulo.Height = 70dip
	End If
	
	Grtitulo.Text = Item.Nome

	Col1.Text = Item.cab1
	Col2.Text = Item.cab2
	Col3.Text = Item.cab3
	
	If Item.UsaImagem = True Then
		' Foi previamente carregada
		LogBmp = RB.CreateBitmap( Item.Imagem)
		Try
			GrImg.Bitmap = LogBmp
			GrImg.Visible = True
			GrImg.Height = 100dip
			GrImg.Width = 100dip
		Catch
			Log(LastException)
			GrImg.Bitmap = Null
		End Try
	Else
		GrImg.Visible =False
		Grtitulo.Left = Grtitulo.Left
	End If
	prG1 = p
	Return True
End Sub

Private Sub CreateItemNivel(Width As Int, Item As ItemEmenta) As Panel
	Dim p As B4XView = xui.CreatePanel("")
	' GERAR O TAMANHO DO PAINEL
	
	Dim height As Int = 0
	' ALTURA DO NÍVEL
	Select Case Item.Nivel
		Case 1
			height = 55dip
		Case 2
			height = 45dip
		Case 3
			height = 40dip
	End Select
	
	p.SetLayoutAnimated(0, 0, 0, Width, height)
	' LAYPUT DE CADA NÍVEL
	Select Case Item.Nivel
		Case 1
			p.LoadLayout("eEscadaN1")
		Case 2
			p.LoadLayout("eEscadaN2")
		Case 3
			p.LoadLayout("eEscadaN3")
	End Select
	
	titulo.Text = Item.Nome
	
	Col1.Text = Item.cab1
	Col2.Text = Item.cab2
	Col3.Text = Item.cab3
	
	Return p
End Sub

Private Sub CreateLinha(Width As Int, info As ItemEmenta) As Panel
	
	Dim p As B4XView = xui.CreatePanel("")
	' GERAR O TAMANHO DO PAINEL
	Dim height As Int = 40dip
	
	p.SetLayoutAnimated(0, 0, 0, Width, height)
	p.LoadLayout("eEscadaLIN")
	
	prato.Text = info.Nome
	
	pvp1.Text = info.pvp1
	pvp2.Text = info.pvp2
	pvp3.Text = info.pvp3
	
	Return p
End Sub


Sub Activity_KeyPress (KeyCode As Int) As Boolean
	If KeyCode = KeyCodes.KEYCODE_BACK  Then
		If Drawer.LeftOpen Then
			Drawer.LeftOpen = False
			Return True
		Else if	bDialogOpen = True Then
			dialog.Close(0)
			bDialogOpen =False
			Return True
		Else
			Drawer.LeftOpen = True
			Return True
		End If
		
	End If
	Return False
End Sub

Sub Activity_Resume

End Sub

Sub Activity_Pause (UserClosed As Boolean)

End Sub

' ================= Mamntemos o pulsar para podermos mudar as cores e frequência.....
Sub PulsarWork()
	CreateHaloEffect(Activity, Activity.Width/2, 2*Activity.Height/3, xui.Color_Gray)
	' Para parar este efeito colocar
	' bStopPulsar = false
End Sub

Sub CreateHaloEffect (Parent As B4XView, x As Int, y As Int, clr As Int)
	Dim cvs As B4XCanvas
	Dim p As B4XView = xui.CreatePanel("")
	Dim radius As Int = 150dip
	
	' ESPERA ORDEM DE TERMINAR
	Do While ( bStopPulsar = False )
		
		p.SetLayoutAnimated(0, 0, 0, radius * 2, radius * 2)
		cvs.Initialize(p)
		cvs.DrawCircle(cvs.TargetRect.CenterX, cvs.TargetRect.CenterY, cvs.TargetRect.Width / 2, clr, True, 0)
		Dim bmp As B4XBitmap = cvs.CreateBitmap
		For i = 1 To 5
			If bStopPulsar =True Then Exit
			' PONTO DE SAÍDA
			CreateHaloEffectHelper(Parent,bmp, x, y,  radius)
			' PONTO DE SAÍDA
			If bStopPulsar = False	Then Sleep(400)
		Next
		p.RemoveAllViews()
	Loop
End Sub

Sub CreateHaloEffectHelper (Parent As B4XView,bmp As B4XBitmap, x As Int, y As Int, radius As Int)
	Dim iv As ImageView
	iv.Initialize("")
	Dim p As B4XView = iv
	p.SetBitmap(bmp)
	Parent.AddView(p, x, y, 0, 0)
	Dim duration As Int = 1000
	
	p.SetLayoutAnimated(duration, x - radius, y - radius, 2 * radius, 2 * radius)
	p.SetVisibleAnimated(duration, False)
	' PONTO DE SAÍDA
	If bStopPulsar = False	Then Sleep(duration)
	
	p.RemoveViewFromParent
End Sub


Sub MostarEmenta() As ResumableSub
	Dim bResult As Boolean
	Dim bLoad As Boolean

	' FECHAR OS SINALIZADORES
	btnUP.Visible =False
	btnDown.Visible = False
	
	' Lista de apoio e se está carregada
	Starter.Lista.Apoio = Starter.Lista.Carta(Starter.Lista.Tipo)
	bLoad = Starter.Lista.CartaLoad(Starter.Lista.Tipo)
	

	' Ver o tamanho do menu
	Log(Starter.Lista.apoio.Size)
	Log(Starter.Lista.Sugestoes.Size)
	
	bResult = False
	If bLoad = False Then
		Wait For (Starter.CarregarEmenta(True)) Complete (ListaOK As Boolean)
		bResult = ListaOK
		' Marca lista como carregada
		Starter.Lista.CartaLoad(Starter.Lista.Tipo) = True
	End If

	Wait For (ListarEmenta) Complete (ListaOK As Boolean)
	bResult = ListaOK
	' Vamos Mostar as sugestões se necessário....
	If bMostrouSugestoes = False And Starter.Restaurante.SugestoesChefe = True Then
		' Mostrar as sugestões
		bStopPulsar = True
		Wait For (MostraSugestoes) Complete (ListaOK As Boolean)
		bMostrouSugestoes = True
	End If
	Log(bResult)
	Return bResult
End Sub


Sub MostraSugestoes()As ResumableSub
	' Listar as sugestoes
	Dim d As B4XView = xui.CreatePanel("")
	d.SetLayoutAnimated(0,5%x,15%y, 90%x, 70%y )
	d.LoadLayout("eSugChefe")
	d.SetColorAndBorder(colorP,1dip,colorP,1dip)
	
	dialog.PutAtTop = True
	dialog.BorderWidth = 2
	dialog.ButtonsHeight = 50dip
	dialog.ButtonsTextColor = colorP
	dialog.ButtonsColor = Colors.White
	dialog.BorderColor = Colors.White
	dialog.BackgroundColor = colorP
	
	lblChefe.TextColor = Colors.White
	clvSug.PressedColor = colorP
	
	' Português por defeito
	IdiomaSug =0
	If Starter.Restaurante.nLinguas = 1 Then
		pIdiomaSeg.Visible =False
	Else
		Dim iv As ImageView = ivsPT
		ivsPT.Visible =True
		lblChefe.Text = "Sugestões do Chefe"
		If Starter.Restaurante.UK = True Then
			ivsUK.Visible =True
			iv = ivsUK
		End If
		If Starter.Restaurante.fr = True Then
			ivsFR.Visible =True
			ivsFR.Left = iv.Left + iv.Width + 5
			iv = ivsFR
		End If
		If Starter.Restaurante.es = True Then
			ivsES.Visible =True
			ivsES.Left = iv.Left + iv.Width + 5
			iv = ivsES
		End If
		
	End If
	
	Try
		
		Do While clvSug.Size > 0
			clvSug.RemoveAt(0)
		Loop
	Catch
		Log(LastException)
	End Try
	
'	ivChefe.Bitmap = xui.LoadBitmapResize(File.DirAssets,"chefe.jpg",ivChefe.Width,ivChefe.Height,False)
	ivChefe.Left = (d.Width - ivChefe.Width) / 2
	
	
	For i = 0 To Starter.Lista.Sugestoes.Size - 1
		' PERCORRER A LISTAS DE SUGESTÕES
		Dim xPrato As TypeSugestao
		xPrato = Starter.Lista.Sugestoes.Get(i)
		clvSug.Add(CreateItemSugestao(clvSug.AsView.Width, xPrato,IdiomaSug), xPrato)
	Next
	bDialogOpen = True
	' Mostra  a sugestão...
	Wait For (dialog.ShowCustom(d, "", "", "FECHAR")) Complete (Result As Int)

	bDialogOpen = False
	Return True
	
End Sub

Private Sub CreateItemSugestao(Width As Int, Item As TypeSugestao, idioma As Int) As Panel
	Dim p As B4XView = xui.CreatePanel("")
	' GERAR O TAMANHO DO PAINEL
	
	Dim height As Int = 105dip
	p.SetLayoutAnimated(0, 0, 0, Width, height)
	p.LoadLayout("esPrato")
	Select Case idioma
		Case 1
			esPrato.Text = Item.UkPrato
			esObs.Text = Item.UKObs
		Case 2
			esPrato.Text = Item.FRPrato
			esObs.Text = Item.FRObs
		Case 3
			esPrato.Text = Item.ESPrato
			esObs.Text = Item.ESObs
		Case Else
			esPrato.Text = Item.NomePrato
			esObs.Text = Item.Descritivo
	End Select
	If esPrato.Text.Trim.Length =0 Then
		esPrato.Text = Item.NomePrato
	End If
	
	If esObs.Text.Trim.Length =0 Then
		esObs.Text = Item.Descritivo
	End If
	
	Return p
End Sub


Sub ListarEmenta () As ResumableSub
	
	Dim Item As ItemEmenta
	

	For i = 0 To Starter.Lista.Apoio.Size - 1
		' ELEMENTO DO MENU
		Item = Starter.Lista.Apoio.Get(i)
		' GERAR ITEM OU GRUPO
		Select Case Item.Nivel
			Case 0
				' LINHA DE PRODUTO
				CLV1.Add(CreateLinha(CLV1.AsView.Width, Item), Item)
			Case 1
				' Linha especial de Menu
				wait for (CreateItemTop(CLV1.AsView.Width,Item) ) complete (Success As Boolean)
				If Success Then
					
					CLV1.Add(prG1, Item)
				End If
			Case Else
				CLV1.Add(CreateItemNivel(CLV1.AsView.Width, Item), Item)
		End Select
	Next
	
	Return True

End Sub

Sub CLV1_ItemClick (Index As Int, Value As Object)
	Dim Item As ItemEmenta = Value
	
	If Item.bMenu = False Then
		
		Dim d As B4XView = xui.CreatePanel("")
		Dim xy As Int
		
		d.SetLayoutAnimated(0,10%x, 50dip, 80%x, 220dip)
		d.LoadLayout("eficha")
		
		dialog.PutAtTop = True
		dialog.BorderWidth = 2
		dialog.ButtonsHeight = 50dip
		dialog.ButtonsTextColor = xui.Color_White
		dialog.ButtonsColor = colorP
		
		dialog.BorderColor = colorP
		dialog.BackgroundColor = xui.Color_White
		
		' Mostrar os dados do Restaurante
		If Starter.Restaurante.UsaImagens = False Then
			efFoto.Visible =False
		Else
			If Item.UsaImagem Then
				' VAMOS VER SE JÁ A CARREGOU
				If Item.LoadImg = False Then
					' CARREGA A IMAGEM...
					Wait For (GetImagem(Item)) Complete (ListaOk As Boolean)
				End If
				LogBmp = RB.CreateBitmap( Item.Imagem)
				Try
					efFoto.Bitmap = LogBmp
					efFoto.Visible = True
				Catch
					Log(LastException)
				End Try
			Else
				efFoto.Visible =False
			End If
		End If
		
		' PREENCHER OS DADOS
		efNome.Text = " " & Item.Nome
		efObs.Text = Item.Obs
		efTit1.Text = Item.cab1
		efTit2.Text = Item.cab2
		efTit3.Text = Item.cab3
		
		efPvp1.Text = Item.pvp1
		efPvp2.Text = Item.pvp2
		efPvp3.Text = Item.pvp3

		' fazer ajustes nos posicionamentos
		If efFoto.Visible = False Then
			efObs.Left = efFoto.Left
			efFoto.Width = efNome.Width
			xy = efObs.Left - efFoto.Left
			' AJUSTAR OS OUTROS
		End If
		
		If Item.Obs.Trim.Length = 0 Then
			' sem informação complementar
			efObs.Visible = False
			xy = efTit1.Top - efObs.Top
			efTit1.Top = efTit1.Top - xy
			efTit2.Top = efTit2.Top - xy
			efTit3.Top = efTit3.Top - xy
			efPvp1.Top = efPvp1.Top - xy
			efPvp2.Top = efPvp2.Top - xy
			efPvp3.Top = efPvp3.Top - xy
			d.Height = 150dip
		End If

		' MOSTRAR FICHA DO PRODUTO
		bDialogOpen = True
		Wait For (dialog.ShowCustom(d, "", "", "FECHAR")) Complete (Result As Int)
		bDialogOpen =False
	End If
		
End Sub


Sub CLV1_ReachEnd
	' VIMOS O ÚLTIMA LINHA
	btnDown.Visible = False
End Sub

Sub CLV1_VisibleRangeChanged (FirstIndex As Int, LastIndex As Int)
	' mudou a a área visível...
	Dim nMaxLinha As Int = CLV1.Size - 1
	If LastIndex < nMaxLinha Then
		btnDown.Visible =True
	Else
		btnDown.Visible = False
	End If
	' ESTÁ TOPO
	If FirstIndex >= 1 Then
		btnUP.Visible =True
	Else
		btnUP.Visible =False
	End If
	
End Sub


Sub GetImagem( Item As ItemEmenta ) As ResumableSub

	Dim CmdSQL As String
	
	Select Case Item.Nivel
		Case 0
			CmdSQL	= "SELECT I.ObjImg " & _
						" FROM Linha As L (nolock) " & _
						" INNER JOIN Item AS I (nolock) ON ( L.IdEmp = I.IdEmp AND L.IdItem = I.IdItem ) " & _
							"  WHERE L.IdEmp = " & Starter.Restaurante.EmpID  & _
								" AND L.IdMenu = " & Starter.Restaurante.MenuID & _
								" AND L.IdLinha = " & Item.LinhaId 
		Case 1
			CmdSQL	= "SELECT G.ObjImg " & _
						" FROM IdGr1 AS G (nolock) " & _
							"  WHERE G.IdEmp = " & Starter.Restaurante.EmpID  & _
								" AND G.IdMenu = " & Starter.Restaurante.MenuID & _
								" AND G.IdGr1 = " & Item.IdGr 
			
		Case 2
			CmdSQL	= "SELECT G.ObjImg " & _
						" FROM IdGr2 AS G (nolock) " & _
							"  WHERE G.IdEmp = " & Starter.Restaurante.EmpID  & _
								" AND G.IdMenu = " & Starter.Restaurante.MenuID & _
								" AND G.IdGr2 = " & Item.IdGr 
			
		Case 3
			CmdSQL	= "SELECT G.ObjImg " & _
						" FROM IdGr3 AS G (nolock) " & _
							"  WHERE G.IdEmp = " & Starter.Restaurante.EmpID  & _
								" AND G.IdMenu = " & Starter.Restaurante.MenuID & _
								" AND G.IdGr3 = " & Item.IdGr 
	End Select
			
	Log(CmdSQL)

	Try
		Dim sf As Object = Starter.mysql.ExecQueryAsync("mysql", CmdSQL, Null)
			
		Wait For (sf) mysql_QueryComplete (Success As Boolean, Crsr As JdbcResultSet)
		If Success Then
			' CARREGAR OS DADOS DO RESTAURANTE A PESQUISAR
			Do While Crsr.NextRow
				Item.Imagem = Crsr.GetBlob("ObjImg")
				Item.LoadImg = True
			Loop
			Crsr.Close
		End If
	Catch
		Log(LastException)
	End Try
	
	Return Success
	
End Sub

Sub LogoRest_Click
	' Mostra os dados da empresa
	Dim d As B4XView = xui.CreatePanel("")
		
	d.SetLayoutAnimated(0,10%x, 50dip, 80%x, 300dip)
	d.LoadLayout("eDadosEmp")
		
	dialog.PutAtTop = True
	dialog.BorderWidth = 2
	dialog.ButtonsHeight = 50dip
	dialog.ButtonsTextColor = xui.Color_White
		
	dialog.BorderColor = xui.Color_Black
	dialog.BackgroundColor = xui.Color_Transparent
	
	' PREENCHER OS DADOS
	edNome.Text = Starter.Restaurante.Nome
	edMorada.Text = Starter.Restaurante.Morada
	edLoca.Text = Starter.Restaurante.Localidade
	edCPostal.Text = Starter.Restaurante.CPostal
	edTel.Text = Starter.Restaurante.Telefones
	edEmail.Text = Starter.Restaurante.Email
	edWebSite.Text = Starter.Restaurante.website
	edObs.Text = Starter.Restaurante.Obs

	' MOSTRAR FICHA DA EMPRESA
	bDialogOpen =True
	Wait For (dialog.ShowCustom(d, "", "", "FECHAR")) Complete (Result As Int)
	bDialogOpen =False
End Sub


Sub btOP_Click()
	Dim bt As Button = Sender
	Dim iBtOrigem As Int = bt.Tag
	
	eNomeE.Text = Starter.Restaurante.Carta(iBtOrigem)
	Starter.Lista.Tipo = iBtOrigem
	
	bStopPulsar	= False
	PulsarWork

	Do While CLV1.Size >0
		CLV1.RemoveAt(0)
	Loop
	
	Drawer.LeftOpen =False
	
	Wait For (MostarEmenta) Complete (ListaOK As Boolean)
	If ListaOK = True Then
		bStopPulsar = True
	End If

	bt.Enabled =True
	
	
End Sub


Sub pIdioma_Click
	' mudança de idioma

	Dim x As Object = Sender
	Dim pais As String  = ""
	Dim idioma As Int = 0
	
	Try
		If	GetType(x) = "Button" Then
			Dim bt As Button = Sender
			pais = bt.tag
		else if GetType(x) = "ImageView" Then
			Dim Iv As Button = Sender
			pais = Iv.tag
		Else
			Dim lb As Label = Sender
			pais = lb.tag
		End If
		
	Catch
		Log(LastException)
	End Try
	
	' dados válidos ?
	If pais.Length= 2 Then
		Drawer.LeftOpen =False

		bStopPulsar	= False
		PulsarWork
		Select Case pais.ToUpperCase
			Case "UK"
				idioma = 1
				ivPais.Bitmap = ivUK.Bitmap
			Case "FR"
				idioma = 2
				ivPais.Bitmap = ivFR.Bitmap
			Case "ES"
				idioma = 3
				ivPais.Bitmap = ivES.Bitmap
			Case Else
				idioma = 0
				ivPais.Bitmap = ivPT.Bitmap
		End Select
		
		
		Starter.Lista.idioma =idioma
		

		Do While CLV1.Size >0
			CLV1.RemoveAt(0)
		Loop
		
		Drawer.LeftOpen =False
		
		Wait For (MostarEmenta) Complete (ListaOK As Boolean)
		If ListaOK = True Then
			bStopPulsar = True
		End If
	Else	
		Activity.Finish
	End If
End Sub

Sub btMenu_Click
	Drawer.LeftOpen = True
End Sub

Sub ivPais_Click
	Drawer.LeftOpen = True
End Sub


Sub isvSug_Click
	Dim x As ImageView = Sender
	
	Dim Pais As String = x.Tag
	
	Try
		
		Do While clvSug.Size > 0
			clvSug.RemoveAt(0)
		Loop
	Catch
		Log(LastException)
	End Try
	
	Select Case Pais.ToUpperCase.Trim
		Case "PT"
			lblChefe.Text = "Sugestões do Chefe"
			IdiomaSug = 0
		Case "UK"
			lblChefe.Text = "Chef's Suggestions"
			IdiomaSug = 1
		Case "FR"
			lblChefe.Text = "Suggestions du chef"
			IdiomaSug = 2
		Case "ES"
			lblChefe.Text = "Sugerencias del chef"
			IdiomaSug = 3
						
	End Select
	
	For i = 0 To Starter.Lista.Sugestoes.Size - 1
		' PERCORRER A LISTAS DE SUGESTÕES
		Dim xPrato As TypeSugestao
		xPrato = Starter.Lista.Sugestoes.Get(i)
		clvSug.Add(CreateItemSugestao(clvSug.AsView.Width, xPrato, IdiomaSug), xPrato)
	Next
	
End Sub


Sub btnUPp_Click
	Try
		clvSug.ScrollToItem(1)
	Catch
		Log(LastException)
	End Try
End Sub

Sub btnDownp_Click
	Try
		clvSug.ScrollToItem(clvSug.Size-1)
	Catch
		Log(LastException)
	End Try
End Sub

Sub btnDown_Click
	Try
		CLV1.ScrollToItem(clvSug.Size-1)
	Catch
		Log(LastException)
	End Try
End Sub

Sub btnUP_Click
	Try
		CLV1.ScrollToItem(1)
	Catch
		Log(LastException)
	End Try
End Sub

Sub clvSug_VisibleRangeChanged (FirstIndex As Int, LastIndex As Int)
	' mudou a a área visível...
	Dim nMaxLinhas As Int = clvSug.Size - 1
	
	If LastIndex < nMaxLinhas Then
		btnDownp.Visible =True
	Else
		btnDownp.Visible = False
	End If
	' ESTÁ TOPO
	If FirstIndex > 0 Then
		btnUPp.Visible =True
	Else
		btnUPp.Visible =False
	End If

End Sub

Sub clvSug_ReachEnd
	' VIMOS O ÚLTIMA LINHA
	btnDownp.Visible = False
End Sub
