﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Activity
Version=9.801
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: False
	#IncludeTitle: True
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.

End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.
	Private xui As XUI
	Private dialog As B4XDialog
	Private bStopPulsar As Boolean
	
	Private Drawer As B4XDrawer

	Private btOk As Button
	Private ecCodigo As EditText
	Private lblErro As Label
	Private xui As XUI

	Private emImg As ImageView
	Private clvMenu As CustomListView
	Private btMenu As Button
	
	' Código de Acesso
	Private lblTitMenu As Label
	Private eEcrNome As Label
End Sub

Sub Activity_Create(FirstTime As Boolean)
	' activar o Drawer
	Drawer.Initialize(Me, "Drawer", Activity, 300dip)
	Drawer.CenterPanel.LoadLayout("eEntrada")
	Drawer.LeftPanel.LoadLayout("eMenu")
	
	eEcrNome.Text = Main.AppName

	' carregar o logo da App no «floater»
	emImg.Bitmap = xui.LoadBitmapResize(File.DirAssets,"logo_ltd.jpg",emImg.Width,emImg.Height,False)
	lblTitMenu.Text = "Escolher secção..."
	
	bStopPulsar = True


	'  =============== Configurar a entrada na escolha do restaurante =======
	' Obter a ultima entrada
	ecCodigo.Hint =""
	lblErro.Text = ""
	lblErro.TextColor = xui.Color_White
	lblErro.TextSize =16
	
	' Iniciar so dialogos que vão ser usados
	dialog.Initialize(Activity)

		
End Sub

Sub Activity_Resume

End Sub

Sub Activity_Pause (UserClosed As Boolean)

End Sub


Sub btOk_Click
	' Preencher o código a procurar
	' Fecha o lado esquerdo
	Drawer.LeftOpen = False
	StartActivity("Lista")
	
end  Sub


Sub btCancel_Click
	Activity.Finish
End Sub

' === PULSAR 
Sub PulsarWork()
	CreateHaloEffect(Activity, Activity.Width/2, 2*Activity.Height/3, xui.Color_Gray)
	' Para parar este efeito colocar
	' bStopPulsar = false
End Sub

Sub CreateHaloEffect (Parent As B4XView, x As Int, y As Int, clr As Int)
	Dim cvs As B4XCanvas
	Dim p As B4XView = xui.CreatePanel("")
	Dim radius As Int = 150dip
	
	' ESPERA ORDEM DE TERMINAR
	Do While ( bStopPulsar = False )
		
		p.SetLayoutAnimated(0, 0, 0, radius * 2, radius * 2)
		cvs.Initialize(p)
		cvs.DrawCircle(cvs.TargetRect.CenterX, cvs.TargetRect.CenterY, cvs.TargetRect.Width / 2, clr, True, 0)
		Dim bmp As B4XBitmap = cvs.CreateBitmap
		For i = 1 To 5
			If bStopPulsar =True Then Exit
			' PONTO DE SAÍDA
			CreateHaloEffectHelper(Parent,bmp, x, y,  radius)
			' PONTO DE SAÍDA
			If bStopPulsar = False	Then Sleep(800)
		Next
		p.RemoveAllViews()
	Loop
End Sub

Sub CreateHaloEffectHelper (Parent As B4XView,bmp As B4XBitmap, x As Int, y As Int, radius As Int)
	Dim iv As ImageView
	iv.Initialize("")
	Dim p As B4XView = iv
	p.SetBitmap(bmp)
	Parent.AddView(p, x, y, 0, 0)
	Dim duration As Int = 3000
	
	p.SetLayoutAnimated(duration, x - radius, y - radius, 2 * radius, 2 * radius)
	p.SetVisibleAnimated(duration, False)
	' PONTO DE SAÍDA
	If bStopPulsar = False	Then Sleep(duration)
	
	p.RemoveViewFromParent
End Sub

Sub Activity_KeyPress (KeyCode As Int) As Boolean
	If KeyCode = KeyCodes.KEYCODE_BACK And Drawer.LeftOpen Then
		Drawer.LeftOpen = False
		Return True
	End If
	Return False
End Sub

Sub clvMenu_ItemClick (Index As Int, Value As Object)
	
	' Fecha o lado esquerdo
	Drawer.LeftOpen = False
	
End Sub

Sub btMenu_Click
	
	Drawer.LeftOpen = True
	
End Sub
