﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Service
Version=7.3
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: False
	#ExcludeFromLibrary: True
#End Region

Sub Process_Globals

	' Item de composição da lista de menus
		
	Type ItemEmenta( Nivel As Int, Nome As String, Obs As String, _
					pvp1 As String, pvp2 As String, pvp3 As String, _
					cab1 As String, cab2 As String, cab3 As String, _
					UkNivel1 As String, UKNivel2 As String, UkNivel3 As String, UkDescLinha As String, _
					FRNivel1 As String, FRNivel2 As String, FRNivel3 As String, FRDescLinha As String, _
					ESNivel1 As String, ESNivel2 As String, ESNivel3 As String, ESDescLinha As String, _
					UKObs1 As String, UKObs2 As String, UKObs3 As String, _
					FRObs1 As String, FRObs2 As String, FRObs3 As String, _
					ESObs1 As String, ESObs2 As String, ESObs3 As String, _
					UKObsLinha As String, FRObsLinha As String, ESObsLInha As String, _
					bMenu As Boolean, UsaImagem As Boolean, LoadImg As Boolean, _
					Imagem() As Byte, LinhaId As Int, IdGr As Int, id1 As Int, id2 As Int, id3 As Int, Indice As Int )


	' ===================== TIPOD E DADOS O RESTAURANTE ===================================
	Type TypeRestaurante ( Ok As Boolean, EmpID As Int, NomeEmenta As String, Nome As String, _
							Morada As String , NIf As String, CPostal As String, Localidade As String, _
							Telefones As String, Email As String, website As String, Obs As String, _
							usaLogo As Boolean, LogoTipo() As Byte, DataExport As String, _
							Layout As Int, MenuID As Int, PvpTxt(7) As String, UsaImagens As Boolean, _
							UsaCarta(4) As Boolean, DiaSemana As Int, DataHoje As String, SugestoesChefe As Boolean,  _
							Privacidade As Int, SSID As String, NomeNoMenu As String, _
							Mensagem As String, PrecosOFF As Boolean, UK As Boolean, FR As Boolean, ES As Boolean, _
							nLinguas As Int, MsgEsq As String, MsgDir As String, Carta(4) As String )
	
	Type TypeSugestao ( NomePrato As String, Descritivo As String, _
						UkPrato As String, UKObs As String, _
						FRPrato As String, FRObs As String, _
						ESPrato As String, ESObs As String, _
						UsaImagem As Boolean, Imagem() As Byte )
	
	Type TypeEmenta ( Carta(4) As List, Apoio As List,  _
						CartaLoad(4) As Boolean, _
						Sugestoes As List, Tipo As Int, idioma As Int )
						
	Type TypeMenu( Nome As String, Codigo As String)
	Type TypeBotao( CodigoAcesso As String, SSID As String)	
	
	' As minhas variáveis
	
	Public mysql As JdbcSQL
	
	Private driver As String = "net.sourceforge.jtds.jdbc.Driver"
	Private jdbcUrlRef As String = "jdbc:jtds:sqlserver://$Server$;databaseName=$DataBase$"
	Private jdbcUrl As String = "jdbc:jtds:sqlserver://192.168.1.65:1434;databaseName=MOV2011"
	
	' TEMOS DE CODIFICAR ESTAS SENHA
	
	'Public Username As String = "sa_menu"
	Public Username As String = "171151009171019051190"

	Public Password As String = "033360084460006570181410101580150350068480131021"
	'Public Password As String = "$.CoviXpg.#2020!"
	
	Public ServerSQL As String = "191051111111190920161460111151140111170131"
	'Public ServerSQL As String = "softseguro.com"
	
	Public BaseDados As String  = "MENU"

	
	Public Mensagem As String
	Public OnLine As Boolean
	Public OnMacAdress As Boolean
	Public MacAdress As String
	Public DeviceID As String
	
	Public Restaurante As TypeRestaurante
	Public AccessCode As String
	Public AccessCodeSSID As String
	Public GoDirect As Boolean
		
	' ==== CONTROLO DA VERSÃO / APLICAÇÃO =================	
	Public LastVersao As String
	Public TipoApp As String = ""
	
	' Dados para o menu de Empresas
	Public MenuEmp As List
	
	Public Sugestoes As List
	
	Public Botoes As List
	
End Sub

Sub Service_Create
	'need to disable it as reading from large JdbcResultSet will cause network requests to be sent on the main thread.
	DisableStrictMode
End Sub

Sub Service_Start (StartingIntent As Intent)
	Dim jo As JavaObject = Me
	' LIGAÇºAO Á BASE DE DADOS OFF
	OnLine =False
	' NÃO ENCONTROU PLACA WIFI
	OnMacAdress = False
	' VAMOS OBTER A PLCA DE REDE WIFI
	Try
		MacAdress= jo.RunMethod("getWifiMacAddress", Null)
		
		OnMacAdress = True
	Catch
		MacAdress = LastException
	End Try
	
	Dim ObjDevice As clsPosto
	ObjDevice.Initialize
	' ESTA APLICAÇÃO TEM O CÓDIGO INTERNO > 35
	If OnMacAdress = True Then
		DeviceID = ObjDevice.GerarCodigo(35, MacAdress)
	Else
		DeviceID = ObjDevice.Codigo
	End If
	
	' ESTÁ MARCADP COMO FALSO
	Restaurante.Initialize
	
	MenuEmp.Initialize
	
	Username = RB.DescodificaSTR(Username)
	Password = RB.DescodificaSTR(Password)
	ServerSQL = RB.DescodificaSTR(ServerSQL)
	
	
	
	Restaurante.Ok = False	
End Sub

Sub DisableStrictMode
	Dim jo As JavaObject
	jo.InitializeStatic("android.os.Build.VERSION")
	If jo.GetField("SDK_INT") > 9 Then
		Dim policy As JavaObject
		policy = policy.InitializeNewInstance("android.os.StrictMode.ThreadPolicy.Builder", Null)
		policy = policy.RunMethodJO("permitAll", Null).RunMethodJO("build", Null)
		Dim sm As JavaObject
		sm.InitializeStatic("android.os.StrictMode").RunMethod("setThreadPolicy", Array(policy))
	End If
End Sub

Sub Connect As ResumableSub
	Dim Success As Boolean
	
	' LIGAR COM O SERVIDOR DE SQL DE FORMA ASYNCRONA
	
	'If OnLine = False  Then
	Dim sConn As String
	Dim mySenha As String
	Dim myUser As String
	
	Dim sConn As String
	sConn = jdbcUrlRef
	sConn = sConn.Replace("$Server$", ServerSQL)
	sConn = sConn.Replace("$DataBase$", BaseDados)
	Log(sConn)
	jdbcUrl = sConn
	

	jdbcUrl = sConn
	myUser = Username
	
	mySenha = Password

	mysql.InitializeAsync("mysql", driver, jdbcUrl, myUser,mySenha)
	Wait For MySQL_Ready (Success As Boolean)
	If Success = False Then
		Mensagem = "Não foi possível ligar com os nossos servidores."
		Log(Mensagem)
		OnLine = False
	Else
		Mensagem = "Ligação estabelecida..."
		Log(Mensagem)
		OnLine = True
	End If

	'Else
		'Log("Ligação operacional")
	'End If
	
	Success = OnLine
	
	Return Success

End Sub


Sub Pesquisar () As ResumableSub
	' VAMOS VERIFICAR SE TEMOS CONNECÇÃO
	Dim CmdSQL As String
	Wait For (Connect) Complete (Success As Boolean)
	
	If Success Then
		Try
			' VAMOS CRIAR O COMANDO SQL  DE PESQUISA DO ACESSO
			
			CmdSQL	= "SELECT Ver FROM Versao WHERE App = " & RB.CvTextoSQL(TipoApp)

			Dim sf As Object = mysql.ExecQueryAsync("mysql", CmdSQL, Null)
			Wait For (sf) mysql_QueryComplete( Ok As Boolean, Crsr As JdbcResultSet)
			If Ok Then

				Do While Crsr.NextRow
					' OBTER A VERSAO
					LastVersao = "" & Crsr.GetString("VER")
				Loop
				Crsr.Close
			Else
				Log(LastException)
				Mensagem = "Acesso inválido"
			End If
		Catch
			Success = False
			Mensagem = "Falha na ligação..."
			Log(LastException)
		End Try
	End If
	Return Success
End Sub


Sub Service_TaskRemoved
	'This event will be raised when the user removes the app from the recent apps list.
End Sub

'Return true to allow the OS default exceptions handler to handle the uncaught exception.
Sub Application_Error (Error As Exception, StackTrace As String) As Boolean
	Return True
End Sub

Sub Service_Destroy

End Sub

#if JAVA
import java.net.NetworkInterface;
import java.util.Collections;
import java.util.List;
public static String getWifiMacAddress() {
  try {
  String interfaceName = "wlan0";
  List<NetworkInterface> interfaces = Collections.list(NetworkInterface.getNetworkInterfaces());
  for (NetworkInterface intf : interfaces) {
  if (!intf.getName().equalsIgnoreCase(interfaceName)){
  continue;
  }

  byte[] mac = intf.getHardwareAddress();
  if (mac==null){
  return "";
  }

  StringBuilder buf = new StringBuilder();
  for (byte aMac : mac) {
  buf.append(String.format("%02X:", aMac));
  }
  if (buf.length()>0) {
  buf.deleteCharAt(buf.length() - 1);
  }
  return buf.toString();
  }
  } catch (Exception ex) {
     ex.printStackTrace();
  }
  return "";
   }
#end if
