﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.5
@EndOfDesignText@
Sub Class_Globals
	Private CfgMap As Map
	Private m_fileMap As String
	Private m_Mensagem As String
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize
	CfgMap.Initialize
	m_fileMap = "cfgPostoSS.map"
	m_Mensagem =""
End Sub

Public Sub Mensagem() As String
	Return m_Mensagem
End Sub
Public Sub SaveMapa() As Boolean
	Dim bResult As Boolean = True
	Try
		File.WriteMap(File.DirInternal,m_fileMap, CfgMap)
	Catch
		Log(LastException)
		m_Mensagem = "Save Map Cfg:" & LastException
		bResult = False 
	End Try
	Return bResult
End Sub

Public Sub LoadMap() As Boolean
	Dim bResult As Boolean  = False
	CfgMap.Initialize
	Try
		If File.Exists(File.DirInternal, m_fileMap) Then
			CfgMap = File.ReadMap( File.DirInternal, m_fileMap)
			bResult = True
		End If
	Catch
		Log(LastException)
		m_Mensagem = LastException
		bResult = False
	End Try

	If bResult = False Then
		' VAMOS INICIAR O MAP MANUALMENTE
		Try
			' da mesa x a y
			CfgMap.Put("MX","")
			CfgMap.Put("MY","zzz")
			' da locaização x a y
			CfgMap.Put("LX","")
			CfgMap.Put("LY","zzz")
			' do produto x a y
			CfgMap.Put("PX","")
			CfgMap.Put("PY","zzz")
			' da famíla x a y
			CfgMap.Put("FX","")
			CfgMap.Put("FY","zzz")
			' da classe x a y
			CfgMap.Put("CX","")
			CfgMap.Put("CY","zzz")
			' Nº DE LINHAS E COLUNAS - MESAS
			CfgMap.Put("MC",4) ' COLUNAS
			CfgMap.Put("ML","4") ' LINHAS
			' Nº DE LINHAS E COLUNAS - PRODUTOS
			CfgMap.Put("PC",4) ' COLUNAS
			CfgMap.Put("PL","4") ' LINHAS
			
		Catch
			Log(LastException)
			m_Mensagem = LastException
			bResult = False
		End Try
		
	End If
	Return bResult
End Sub

Public Sub Get(sKey As String) As String
	Dim sSaida As String = ""
	Try
		sSaida = CfgMap.Get(sKey)
	Catch
		Log(LastException)
	End Try
	Return sSaida
End Sub
	
Public Sub Put( skey As String, sValue As String)
	CfgMap.Put(skey, sValue)
End Sub
